        page 250,150

;Description-----------------------------------------------------
;
; CFTest: testprogram for an internal CompactFlash <-> Atari
; PortFolio interface.
;
; Version: 0.01 (30-01-2000)
;
; The program is a small command-driven interface test program.
; It supports disk ident, read block, write block and LBA
; setting for my CompactFlash interface.
;
; Commands:
;
; i: do disk ident
; r: read a 512-bytes block from the CF
; w: write a 512-bytes block to the CF
; l: set the LBA for the previous read/write block operations
; d [start][number]: dump a part of the buffer used for this read/
;         write block operations.
;         [start] : optional start address of the dump
;         [number]: optional number of bytes to dump
; e [start]: edit the buffer.
;         [start] : optional start of edit within the buffer
; c: Set CompactFlash to low-current modus (should be the first
;    command to issue if you don't want the CF to make your pofo
;    power supply to collapse....)
;
; Copyright notice:
; -----------------
;
; (C) 30-01-2000 by P.R. Faasse, Hakfort 635, 1102 LA Amsterdam
;
;   This program is free software; you can redistribute it and/or modify
;   it under the terms of the GNU General Public License as published by
;   the Free Software Foundation; either version 2 of the License, or
;   (at your option) any later version.
;
;   This program is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with this program; if not, write to the Free Software
;   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
; Warranty elaboration:
; ---------------------
;
; As nearly all computer programs this code comes  without any
; warranty. When using this code I am not responsible if anything
; goes wrong with your hardware/software, data, married life or
; otherwise.
;
; I've tried my very best to make this program work; I've seen it
; work on one of my PortFolio's with an 8MB SanDisk CompactFlash
; module. The development of the PoFoCF interface is in a rather
; early state of it's development. Thta means that I've not yet
; done extensive testing of the hard- and/or software yet. I'd
; classify this code as early alpha software, so be warned.
;
; Bugs/error reporting:
; ---------------------
; Any reports of errors are welcome. I can again guarantee
; nothing, but as long as I'm interested in PortFolio's there is
; a very good chance that I'll do my best to kill any remaining
; bugs. I prefer error reports in e-mail form to:
;
;       faasse@nlr.nl
;
; If e-mail is not available to you you could also send a written
; report to:
;
;       P.R. Faasse
;       Hakfort 635
;       1102 LA Amsterdam
;       Netherlands
;
;End-------------------------------------------------------------

;Header----------------------------------------------------------
;
; MASM needs this cryptic piece of text to be able to make an
; .OBJ file. I have mainly copied it from a textbook. I do not
; really know what all this gougou means.
;
code    segment para 'code'     ; define code segment
        org   0100h             ; start at offset 0100H
        assume cs:code, ds:code, es:code, ss:code
;
; This is the starting address of the thing ....
;
start:  jmp     init            ; do init actions
;
;End------------------------------------------------------------

;Params---------------------------------------------------------
;
;
;End------------------------------------------------------------

;Data-----------------------------------------------------------
;
databuf equ     080H            ; DTA
ioofs   dw      0               ;
ionum   dw      028H            ;
;
LBA     dw      0               ; LBA
;
        ; This one is used fo bothe normal and driver buffer dump
dmess   db      "adr: 08 19 2A 3B 4C 5D 6E 7F 01234567",CR,LF,EOS

StartMess  db      "PoFo <-> CompactFlash interface test",cr,lf
           db      "program. by: P.R. Faasse",cr,lf
           db      "version 0.01 (30-01-2000)",cr,lf,eos

;End------------------------------------------------------------

;Defs-----------------------------------------------------------
;
; All defines of parameters that are not bytes etc..
;
; constants
;
cr      equ     00DH            ; ASCII Carriage Return
lf      equ     00AH            ; ASCII Line Feed
eos     equ     '$'             ; PC's End Of Message
;
; PoFo services I'm going to use
;
PoFo            equ     061H    ; PoFo services Int
;
; the int 61H functions
;
PoFoInit        equ     0000H   ; init 61H functions
PoFoGetCCM      equ     2400H   ; get CCM status
PoFoSetCCM      equ     2401H   ; set CCM status
PoFoSetCf       equ     0101H   ; set CCM a: banked set in dl
;
; CF I/O adresses
;
CFData  equ     0F000H  ;
CFError equ     0F001H  ; read
CFFeat  equ     0F001H  ; write
CFSCnt  equ     0F002H  ;
CFFeatPar  equ  0F002H  ; features parameter
CFLBA0  equ     0F003H  ;
CFLBA1  equ     0F004H  ;
CFLBA2  equ     0F005H  ;
CFLBA3  equ     0F006H  ;
CFStat  equ     0F007H  ; read
CFCmd   equ     0F007H  ; write
;
CFLBA3OM equ     0E0H   ; OR  mask for LBA3 -> LBA modus
CFLBA3AM equ     0EFH   ; And mask for LBA3 -> LBA modus
;
CmdIdent        equ     0ECH    ; ident command
CmdRead         equ     020H    ; read sector(s) command
CmdWrite        equ     030H    ; write sector(s) command
CmdFeat         equ     0EFH    ; set features command
;
; The bits from IDE Status register
;
StsBsy          equ     10000000B       ; busy flag
StsRdy          equ     01000000B       ; ready flag
StsWft          equ     00100000B       ; Write error
StsSKC          equ     00010000B       ; seek complete
StsDRQ          equ     00001000B       ; Data Request
StsCorr         equ     00000100B       ; ECC executed
StsIdx          equ     00000010B       ; Index found
StsErr          equ     00000001B       ; error flag
;
        ; a small macro to make entering the command table
        ; easier
Cmd     macro   CmdChar,CmdHand         ; I nicked some
        db      '&CmdChar'              ; handy macro-tricks
        dw      CmdHand                 ; from Klaus in the
        endm                            ; pofoide/ddt time..
;
        ; command prompt
pmess   db      ">",EOS
;
;End------------------------------------------------------------

;Debug----------------------------------------------------------
;
; defines for debugging purposes:
; A ddt names table. This does increase the code size, but in this
; alfa-software i'll sacrifica the 200 bytes it takes for the gain
; of an easily debuggable piece of software. If this thing EVER
; becomes production software (a testprogram... don't think so) the
; names table will be taken out..
;
; un-comment the next line to get a names table
With_NT equ    1        ; names tabel ON

; check if the names table is requested.
IFDEF With_NT

        ; This macro NM can make life a load easier
        ; when creating a name table. NB: ANY location in
        ; the code can be in the name table. The disassembler
        ; will show the name with the location. Note that the
        ; parameter NtName is used twice in the macro, first
        ; to get the offset of the address in the cs, seccond
        ; as the string to be printed. The names table mechanism
        ; does not require these to be the same, it is the most
        ; obvious way to use the name table however

        ; name table entry definition macro
NM      macro   NtName
        dw      NtName
        db      '&NtName',0
        endm

        ; signal string for ddt. It will recognize the
        ; existence of the table when it finds this string.
        db      'ddt nt'        ; for ddt: name table follows

        ; The macro can make life a load easier here
        ; simply: NM <name of label to put in the name table>
        ; Note: comment is allowed here...
        nm      Main            ; the start of the code
        nm      DisHexByte      ; display hex byte
        nm      DisHexWord      ; display hex word
        nm      HexDig          ; display hexdigit
        nm      NewLine         ; goto new line
        nm      WaitNBsy        ; wait till CF not busy
        nm      WaitDRQ         ; wait till CF data request
        nm      ReadBlock       ; read data block from CF
        nm      ReadSts         ; read CF's status register
        nm      Ident           ; do CF ident
        nm      IdentReport     ; report ident results
        nm      DisChar         ; display a character
        nm      AscWStr         ; display ASCII word string
        nm      FinWait         ; finish waiting for CF
        nm      Mess            ; print message
        nm      CI              ; Command Interpreter

        ;end of name table: DO not FORGET, else the disassembler
        ; will probably simply crash....
        dw      0               ; end of table is
        db      0               ; an all-zero entry

ENDIF
;End------------------------------------------------------------

;Program--------------------------------------------------------
;
; The transient program part. In the final code this part will
; have to move to the back of the program, so it can be released
; to DOS (DIP) when it is done. For now I keep it here.. I still
; have to find out how to combine uninitialized data with this
; transient program behaviour.
;
prog    proc near               ; the actual program
;
main:
        ; Init message
        mov     dx,offset StartMess
        call    Mess            ;

        ; give prompt
MainC:  call    Prompt                  ; send prompt

        ; get user input
        call    Input                   ;
        jc      MainC                   ; ignore empty input

        ; get command pointer
        mov     al,[si]                 ; get opcode

        ; make si -> pars (if any..)
MainP1: inc     si                      ;
        cmp     byte ptr [si],0         ; end of command
        jz      MainPe                  ;

        ; skip rest of command
        cmp     byte ptr [si],' '       ; skip non-spaces
        jnz     MainP1                  ;

        ; di -> command; si -> parameters
MainPe: nop                             ; end of Main parameter handling

        ; test if driver/non-driver command set
        mov     di,offset CommandTab    ; just debugger
MainC1: call    CI                      ;
        jmp     MainC                   ;

CommandTab:
        Cmd     q,MainEnd               ; q -> end of program
        Cmd     i,Ident                 ; i -> disk ident
        Cmd     d,drvDataBuf            ; d -> dump databuffer
        Cmd     e,drvEdit               ; e -> edit sector buffer
        Cmd     l,SetLBA                ; l -> Set the LBA for I/O
        Cmd     r,ReadSec               ; r -> read sector
        Cmd     w,WriteSec              ; w -> write sector
        Cmd     c,SetCurrent            ; c -> set low-current

        db      0FFH                    ; end of table
        dw      Error                   ;

        ; for the moment that is it...
mainend:mov     ax,04C00H               ;
        int     21h                     ;


SetLba: call    GetHexWord              ;
        mov     lba,ax                  ;
        ret

        ; set minimum current usage modus
SetCurrent:
        call    WaitNBsy        ;
        mov     al,1            ; set lowset power
        mov     dx,CFFeatPar    ;
        out     dx,al           ;
        mov     al,09AH         ; set power feature
        mov     dx,CfFeat       ;
        out     dx,al           ;
        mov     al,CmdFeat      ; features command
        mov     dx,CfCmd        ;
        out     dx,al           ;
        ret                     ;

ReadSec:call    WaitNBsy                ;

        mov     al,1                    ;
        mov     dx,CFScnt               ;
        out     dx,al                   ;

        mov     ax,lba                  ;
        mov     dx,CFLBA0               ;
        out     dx,al                   ;
        mov     al,ah                   ;
        mov     dx,CFLBA1               ;
        out     dx,al                   ;
        mov     al,0                    ;
        mov     dx,CFLBA2               ;
        out     dx,al                   ;
        mov     al,CFLBA3OM             ;
        mov     dx,CFLBA3               ;
        out     dx,al                   ;

        mov     al,CmdRead              ;
        mov     dx,CfCmd                ;
        out     dx,al                   ;

        call    WaitDRQ                 ;
        call    ReadBlock               ;

        ret                             ;

WriteSec:
        call    WaitNBsy                ;
        mov     al,1                    ;
        mov     dx,CFScnt               ;
        out     dx,al                   ;

        mov     ax,lba                  ;
        mov     dx,CFLBA0               ;
        out     dx,al                   ;
        mov     al,ah                   ;
        mov     dx,CFLBA1               ;
        out     dx,al                   ;
        mov     al,0                    ;
        mov     dx,CFLBA2               ;
        out     dx,al                   ;
        mov     al,CFLBA3OM             ;
        mov     dx,CFLBA3               ;
        out     dx,al                   ;

        mov     al,CmdWrite             ;
        mov     dx,CfCmd                ;
        out     dx,al                   ;

        call    WaitDRQ                 ;
        call    WriteBlock              ;

        ret                             ;

;--------------------------------------------------
; Error handler
;--------------------------------------------------

Error:  mov     dx,offset cerr          ;
        call    Mess                    ;
        ret                             ;

cerr:   db      "Pardon?",cr,lf,eos

;----------------------------------------------------
; Routine/handler CI
; purp  : a command Interpreter for the 8088
; in    : al = command char
;         ds:di -> command table
; out   : control transfered to the 'routine' indicated
; uses  : flags, si

CI:     cmp     byte ptr [di],0FFH      ; test end of table
        jz      CiFound                 ;
        cmp     al,[di]                 ; test for match
        jz      CiFound                 ;

        ; skip this entry
        add     di,3                    ;
        jmp     CI                      ;

CiFound:inc     di                      ;
        push    [di]                    ;
        ret                             ;


NewLine:push    dx                      ;
        mov     dx,offset NlStr         ;
        call    Mess                    ;
        pop     dx                      ;
        ret                             ;

NLStr:  db      CR,LF,EOS

Mess:   push    ax                      ;
        mov     ax,0900H                ;
        int     21H                     ;
        pop     ax                      ;
        ret                             ;

DisChar: push    ax                      ;
        push    dx                      ;
        mov     dl,al                   ;
        mov     ax,0200H                ;
        int     21H                     ;
        pop     dx                      ;
        pop     ax                      ;
        ret                             ;

DisHexWord:push    ax              ;
        mov     al,ah           ;
        call    DisHexByte         ;
        pop     ax              ;
        call    DisHexByte         ;
        ret                     ;

DisHexByte:
        push    ax              ;
        shr     al,1            ;
        shr     al,1            ;
        shr     al,1            ;
        shr     al,1            ;
        call    HexDig          ;
        pop     ax              ;
        push    ax              ;
        call    HexDig          ;
        pop     ax              ;
        ret                     ;

HexDig: push    ax              ;
        and     al,00FH         ;
        cmp     al,0AH          ;
        jnc     HexDig1         ;
        add     al,'0'          ;
        jmp     HexDig2         ;
HexDig1:add     al,('A' - 0AH)  ;
HexDig2:call    DisChar          ;
        pop     ax              ;
        ret                     ;

AscWStr:lodsw                   ;
        push    ax              ;
        mov     al,ah           ;
        call    DisChar          ;
        pop     ax              ;
        call    DisChar          ;
        loop    AscWStr         ;
        ret                     ;

        ; read ident block
Ident:  call    WaitNBsy        ;
        mov     al,CmdIdent     ;
        mov     dx,CfCmd        ;
        out     dx,al           ;
        call    WaitDRQ         ;
        call    ReadBlock       ;
        call    IdentReport     ;
        ret                     ;

        ; go dump some of the ident information
IdentReport:

        ; model
        mov     dx,offset ModStr;
        call    Mess            ;
        mov     cx,15           ;
        mov     si,offset(DiskBlock+(2*27))
        call    AscWStr         ;
        call    NewLine         ;

        ; Serial Number
        mov     dx,offset SerStr;
        call    Mess            ;
        mov     si,offset (DiskBlock+(2*10))
        mov     cx,10           ;
        call    AscWStr         ;
        call    NewLine         ;

        ; revision
        mov     dx,offset RvStr ;
        call    Mess            ;
        mov     cx,4            ;
        mov     si,offset(DiskBlock+(2*23))
        call    AscWStr         ;
        call    NewLine         ;

        ; disk size
        mov     dx,offset SzStr ;
        call    Mess           ;
        mov     ax,word ptr (DiskBlock+(2*7))
        call    DisHexWord         ;
        mov     ax,word ptr (DiskBlock+(2*8))
        call    DisHexWord         ;
        mov     dx,offset SzStr1;
        call    Mess           ;
        call    NewLine         ;

        ret                     ;

ModStr: db      "Model: ",EOS
SerStr: db      "SerNo: ",EOS
RvStr:  db      "Rev  : ",EOS
SzStr:  db      "Size : ",EOS
SzStr1: db      " (hex) Sectors",EOS

;---------------------------------------------------------------
; Routine ReadSts
; purp: get status if the IDE device
; in  : nothing
; out : status byte in al
; uses: ax

ReadSts:
        push    dx              ;
        mov     dx,CFStat       ;
        in      al,dx           ;
        pop     dx              ;
        ret                     ;

;---------------------------------------------------------------
; Routine ReadBlock
; purp: Read one 512-bytes block from the CF
; in  : nothing
; out : nothing
; uses: ax

ReadBlock:
        push    ax              ;
        push    cx              ;
        push    dx              ;
        push    di              ;

        mov     cx,0200H        ;
        mov     dx,CFData       ;
        mov     di,offset diskblock

rdblk1: in      al,dx           ;
        stosb                   ;
        loop    rdblk1          ;

        pop     di              ;
        pop     dx              ;
        pop     cx              ;
        pop     ax              ;

        ret                     ;

;---------------------------------------------------------------
; Routine WriteBlock
; purp: write one 512-bytes block to the CF
; in  : nothing
; out : nothing
; uses: ax

WriteBlock:

        push    ax              ;
        push    cx              ;
        push    dx              ;
        push    si              ;

        mov     cx,0200H        ;
        mov     si,offset diskblock
        mov     dx,CFData       ;

wrblk1: lodsb                   ;
        out     dx,al           ;
        loop    wrblk1          ;

        pop     si              ;
        pop     dx              ;
        pop     cx              ;
        pop     ax              ;

        ret                     ;

;---------------------------------------------------------------
; Routine WaitNBSY
; purp: wait till the drive indicates ready status
; in  : nothing
; out : nothing
; uses: nothing

WaitNBSY:
        push    ax              ; save registers

        ; test if device ready
wtrdy1: call    ReadSts         ; get status byte
        and     al,11110000B    ; get status bits
        cmp     al,01010000B    ;
        jz      FinWait         ;
        jmp     wtrdy1          ; wait for it

;---------------------------------------------------------------
; Routine WaitDRQ
; purp: wait till the drive indicates ready for data transfer
; in  : nothing
; out : nothing
; uses: nothing

WaitDRQ:
        push    ax              ; save registers

        ; test if device ready
wtdrq1: call    ReadSts         ; get status byte
        and     al,11111000B    ; get status bits
        cmp     al,01011000B    ;
        jz      FinWait         ;
        jmp     wtdrq1          ; wait for it

;---------------------------------------------------------------
; Fragment FinWait
; purp: finishes up things when waiting for something is done
; in  : ax still on stack
; out : nothing
; uses: nothing
; NB  : this code fragment is a result of code compression
;       it is used by the routines WaitDRQ, WaitNBSY and
;       WaitDRDY

FinWait:pop     ax              ; get ax back from stack 
        ret                     ; routine done

;--------------------------------------------------
; Driver buffer Edit handler
;--------------------------------------------------

DrvEdit:
        ; handle default parameters
        call    SkipSp          ; look for parameters
        jc      drvdoedit       ;

        ; get start address
        call    GetHexWord      ; read offset address
        mov     ioofs,ax        ;

        ; go edit
drvdoedit:
        mov     ax,ioofs        ;
        call    DisHexWord      ;
        mov     al,' '          ;
        call    DisChar          ;
        mov     si,ioofs        ;
        mov     al,byte ptr [si+DiskBlock]
        call    DisHexByte      ;
        mov     al,':'          ;
        call    DisChar         ;

        ; get new input
        call    Input           ;
        jnc     drvedit0        ;

        ; leave unchanged
        mov     ax,ioofs        ;
        inc     ax              ;
        and     ax,01FFH        ;
        mov     ioofs,ax        ;
        jmp     drvdoedit       ;

        ; test for commands
drvedit0:
        cmp     byte ptr [si],'q'       ; quit
        jnz     drvedit1        ;
drvedte:ret                     ;

drvedit1:
        cmp     byte ptr [si],'-'       ; decrement pointer
        jnz     drvedit2        ;
        mov     ax,ioofs        ;
        dec     ax              ;
        and     ax,01FFH        ;
        mov     ioofs,ax        ;
        jmp     drvdoedit       ;

drvedit2:
        call    GetHexByte      ; other = hex byte, store
        jc      drvedte         ;
        mov     si,ioofs        ;
        mov     byte ptr [si+DiskBlock],al     ; store byte
        inc     ioofs
        jmp     drvdoedit       ;

;--------------------------------------------------
; Data Buffer display
;--------------------------------------------------

DrvDataBuf:
        ; handle default parameters
        call    SkipSp          ; look for parameters
        jc      drvdmp          ;

        ; get start address
        call    GetHexWord      ; read address
        and     ax,01F8H        ; make 8 byte boundary,
        mov     ioofs,ax        ; max = 512 bytes
        call    SkipSp          ; skip spaces
        jnc     drvdmp0         ;

        ; only one par, go dump with this
        jmp     drvdmp          ;

        ; second par too
drvdmp0:call    GetHexWord      ;
        add     ax,7            ;
        and     ax,0FFF8H       ;
        mov     ionum,ax        ;

        ; go execute a dump
drvdmp: mov     dx,offset dmess ; print header
        call    Mess            ;

        ; get data from driver I/O buffer
        mov     bx,ionum        ;
        mov     ax,ioofs        ;
        and     ax,01F8H        ;
        mov     si,ax           ;

        ; go dump memory
drvp1:  mov     ax,si           ; test if ready
        and     ax,01FFH        ;
        mov     si,ax           ;
        cmp     bx,0            ;
        jz      drvpe           ;

        ; save si for ASCII dump
        push    si              ;

        ; Display address
        mov     ax,si           ;
        call    DisHexWord      ;

        ; 8 bytes hex
        mov     cx,8            ; dump 8 bytes
drvp2:  mov     al,' '          ;
        call    DisChar         ;
        mov     al,byte ptr cs:[si+DiskBlock];
        call    DisHexByte      ;
        inc     si              ;
        dec     bx              ;
        loop    drvp2           ;

        mov     al,' '          ; space between
        call    DisChar         ;

        ; ASCII (if this goes)
        mov     cx,8            ; dump ASCII part
        pop     si              ;
drvp3:  mov     al,byte ptr cs:[si+DiskBlock] ;
        cmp     al,' '          ; I do not dump below <SP>
        jc      drvp5           ;

drvp4:  call    DisChar         ;
        inc     si              ;
        loop    drvp3           ;

        call    NewLine         ;
        jmp     drvp1           ;

drvp5:  mov     al,'.'          ;
        jmp     drvp4           ;

        ; dump done
drvpe:  mov     ax,ionum        ;
        add     ax,ioofs        ;
        and     ax,01F8H        ;
        mov     ioofs,ax        ;

        ; get next command
        ret                     ;

; --------------------------------------
; Routine FrHex
; purp  : converts ASCII hex character to nibble
; in    : ASCII char in al
; out   : nibble in al, carry clear if 0 .. 9 or A .. F or a .. f
;         carry set and al unchanged if no hex nibble
; uses  : nothing

FrHex proc near

        pushf                   ;

        ; test for 0 .. 9
        cmp     al,'0'          ;
        jl      frhexn          ;
        cmp     al,'9'          ;
        jg      frhex1          ;

        ; is 0 .. 9 -> convert
        and     al,0FH          ;
frhexe: popf                    ;
        clc                     ;
        ret                     ;

        ; test A .. F
frhex1: cmp     al,'A'          ;
        jl      frhexn          ;
        cmp     al,'F'          ;
        jg      frhex2          ;

        ; A .. F -> convert
        sub     al,'A'          ;
        add     al,0AH          ;
        jmp     frhexe          ;

        ; test a .. f
frhex2: cmp     al,'a'          ;
        jl      frhexn          ;
        cmp     al,'f'          ;
        jg      frhexn          ;

        ; a .. f -> convert
        sub     al,'a'          ;
        add     al,0AH          ;
        jmp     frhexe          ;

        ; error
frhexn: popf                    ;
        stc                     ;
        ret                     ;

FrHex endp

; --------------------------------------
; Routine Input
; purp  : user input (buffered) from keyboard
; in    : nothing
; out   : carry set if empty input or only spaces input
;         else: input in databuf, ASCIZ, si -> first non-space
; uses  : databuf

Input proc near                         ; all procs are near

        push    ax                      ;
        push    bx                      ;
        push    dx                      ;
        push    di                      ;

        ; get command string
        mov     ax,0A00H                ; buffered input
        mov     di,databuf              ; 120 chars for command
        mov     byte ptr [di],120       ;
        mov     dx,databuf              ;
        int     21H                     ; get data buffer

        ; goto next line
        call    NewLine                 ;

        ; make to ASCIZ buffer
        mov     si,(databuf+1)          ;
        mov     bl,[si]                 ;
        mov     bh,0                    ;
        inc     si                      ; si -> first char
        mov     byte ptr [si+bx],0      ; make ASCIZ string

        ; skip leading spaces
        call    SkipSp                  ;

        ; restore registers
        pop     di                      ;
        pop     dx                      ;
        pop     bx                      ;
        pop     ax                      ;
        ret                             ;

Input endp

; --------------------------------------
; Routine GetHexByte and GetHexWord
; purp  : gets a hex byte/word to al/ax
; in    : si -> command string
; out   : byte in AL (GetHexByte)
;         word in AX (GetHexWord)
; uses  : nothing

GetHexWord proc near            ; all procs are near

        push    bx              ;
        push    cx              ;

        call    SkipSp          ;
        jc      ghwe            ;

        ; get nibbles
        mov     cx,4            ;
        mov     bx,0            ;

        call    Getchar         ;
        jc      ghwe            ;
        call    FrHex           ;
        jc      ghwe            ;
        jmp     ghw2            ;

        ; get a character
ghw1:   call    GetChar         ;
        jc      ghwf            ;
        call    FrHex           ;
        jc      ghwf            ;
ghw2:   shl     bx,1            ;
        shl     bx,1            ;
        shl     bx,1            ;
        shl     bx,1            ;
        mov     ah,0            ;
        add     bx,ax           ;
        loop    ghw1

ghwf:   mov     ax,bx           ;
        clc                     ;

ghwe:   pop     cx              ;
        pop     bx              ;
        ret                     ;

GetHexWord endp

GetHexByte proc near            ; all procs are near

        push    bx              ;
        push    cx              ;

        call    SkipSp          ;
        jc      ghbe            ;

        ; get nibbles
        mov     cx,2            ;
        mov     bx,0            ;

        call    GetChar         ;
        jc      ghbe            ;
        call    FrHex           ;
        jc      ghbe            ;
        jmp     ghb2            ;

        ; get a character
ghb1:   call    GetChar         ;
        jc      ghbf            ;
        call    FrHex           ;
        jc      ghbf            ;
ghb2:   shl     bx,1            ;
        shl     bx,1            ;
        shl     bx,1            ;
        shl     bx,1            ;
        mov     ah,0            ;
        add     bx,ax           ;
        loop    ghb1

ghbf:   mov     ax,bx           ;
        clc                     ;

ghbe:   pop     cx              ;
        pop     bx              ;
        ret                     ;

GetHexByte endp

; --------------------------------------
; Routine GetChar
; purp  : get one ASCII character
; in    : si -> character buffer
; out   : nothing
; uses  : nothing

GetChar proc near

        mov     al,[si]         ; get a character
        cmp     al,0            ; test for end of string
        jz      getchar1        ; -> error return
        inc     si              ; point to next character
        clc                     ; ok return
        ret                     ;

getchar1:
        stc                     ; error return
        ret                     ;

GetChar endp

; --------------------------------------
; Routine SkipSp
; purp  : skip spaces in string
; in    : si -> string
; out   : carry set if end of string found
;         else si -> first non-space char in the string
; uses  : nothing

SkipSp proc near

        ; skip leading spaces
skip1:  cmp     byte ptr [si],0         ; 00 = end of string
        jz      skip3                   ;

        cmp     byte ptr [si],' '       ; test for space
        jnz     skip2                   ; other is character
        inc     si                      ; skip the space
        jmp     skip1                   ; next char

skip2:  clc                             ; character found
        ret                             ;

skip3:  stc                             ; end of string found
        ret                             ;

SkipSp endp

; --------------------------------------
; Routine Prompt
; purp  : write prompt to user
; in    : nothing
; out   : mothing
; uses  : nothing

Prompt proc near

        mov     dx,offset pmess ; give prompt message
        call    Mess            ;
        ret                     ;

Prompt endp

;End-------------------------------------------------
;
prog    endp                    ;
;
;End-------------------------------------------------

;Init------------------------------------------------
;
; Initialisation code, releases all unused memory to
; DOS (DIP in this case...). This part is for the
; transient program mainly.
;
Init:   mov     ah,4AH          ; free all unused memory
        mov     bx,offset einde ;
        mov     cl,4            ;
        shr     bx,cl           ;
        inc     bx              ;
        int     21H             ;

        ; set the stackpointer
        mov     sp,offset stackinit     ;
        jmp     main                    ;
;
;End-------------------------------------------------

;Unintialized data-----------------------------------
;
; This data is not stored on the disk. I get it when
; the program starts running, I just do not release
; it to DOS.
;
; The disk data I/O block, not needed
diskblock       label near
diskblocksize   equ     0200H
;
;End-------------------------------------------------

;Stack-----------------------------------------------
;
; The program's stack space, not stored on disk. In fact
; this is uninitialized data too, I just use the special
; name it has...
;
stackbegin      equ     diskblock + diskblocksize
stacksize       equ     256                     ; 256 bytes
stackinit       equ     stackbegin + stacksize
;
;End------------------------------------------------

;End-Of-Code----------------------------------------
;
; This part satifies MASM as for the segment etc..
; define of the code. It contains the end-of-segment
; info and some other things needed to satify MASM
;
; All memory locations after the locations einde and
; endresident will be released...
;
einde   equ     stackbegin + stacksize
endresident equ einde
;
; some MASM-satisfiers
;
code    ends            ; end of code segment
                        ;
        end     start   ; end of the program
                        ; entry point = start
;End------------------------------------------------
